Package: org.codehaus.groovy.transform.tailrec

## [Groovy] Class ReturnAdderForClosures

- org.codehaus.groovy.transform.tailrec.ReturnAdderForClosures

- Adds explicit return statements to implicit return points in a closure. This is necessary since tail-recursion is detected by having the recursive call within the return statement.

  Authors:
    Johannes Link

- - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `void` | `visitClosureExpression(ClosureExpression expression)`
    `void` | `visitMethod(MethodNode method)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class CodeVisitorSupport` | `visitReturnStatement, visitConstantExpression, visitClassExpression, visitPropertyExpression, visitListExpression, visitVariableExpression, visitTupleExpression, visitArgumentlistExpression, visitMethodCallExpression, visitClosureExpression, visitExpressionStatement, visitBlockStatement, visitDeclarationExpression, visitAssertStatement, visitBreakStatement, visitCaseStatement, visitBitwiseNegationExpression, visitCastExpression, visitAttributeExpression, visitFieldExpression, visitGStringExpression, visitClosureListExpression, visitBytecodeExpression, visitCatchStatement, visitContinueStatement, visitIfElse, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitStaticMethodCallExpression, visitConstructorCallExpression, visitBinaryExpression, visitTernaryExpression, visitShortTernaryExpression, visitPostfixExpression, visitPrefixExpression, visitBooleanExpression, visitNotExpression, visitArrayExpression, visitMapExpression, visitMapEntryExpression, visitRangeExpression, visitSpreadExpression, visitSpreadMapExpression, visitMethodPointerExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitForLoop, visitSwitch, visitWhileLoop, visitDoWhileLoop, wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Method Detail

    - #### void visitClosureExpression(ClosureExpression expression)

    - #### void visitMethod(MethodNode method)